(*****************************************************************************)
(*                                                                           *)
(*                         ---  DISCUSS.PAS  ---                             *)
(*                                                                           *)
(*                   Hauptprogramm zur Kurvendiskussion                      *)
(*                                                                           *)
(*****************************************************************************)


Program Kurvendiskussion;

const
{$I gsxconst.pas}
type
{$I gsxtype.pas}
var
{$I gsxvar.pas}

(* Unterprogramme *)
{$I gsxvdi.pas}
{$I gsxlib1.pas}
{$I DEF.INC}              (* Definition der Funktion        *)
{$I FUNCTION.INC}         (* Funktionswerte/Ableitungen     *)
{$I SOLVE.INC}            (* Loesen einer Gleichung g(x)=0  *)
{$I TABLE.INC}            (* Erstellen einer Wertetabelle   *)
{$I ROOTS.INC}            (* Berechnung der Nullstellen     *)
{$I EXTREME.INC}          (*                Extremwerte     *)
{$I FLEX.INC}             (*                Wendestellen    *)
{$I INTEGRAL.INC}         (* Integralberechnung             *)
{$I SYMMETRY.INC}         (* Symmetrieueberpruefung         *)
{$I MONOTONY.INC}         (* Monotonieueberpruefung         *)
{$I DRAW.INC}             (* Funktionsgraph zeichnen        *)
{$I MENU3.INC}            (* Menusteuerung                  *)

Begin
Menu
End.
