(*--------------------------------------------------------------------------*)
(*       ein Statik-Programm zur Berechnung von Einfeldtraegern             *)

PROGRAM EinfeldTraeger;

CONST MaxAnzahl = 18;                         (* maximale Anzahl der Lasten *)

TYPE  Lastbild = RECORD     (* charakterisierende Eigenschaften jeder Last: *)
                   Ort,                              (* - Anfangsstelle     *)
                   Laenge,                           (* - Laenge            *)
                   Links,                            (* - Groesse am Anfang *)
                   Rechts  : REAL                    (* - Groesse am Ende   *)
                 END; (* record *)

VAR   Last                    : ARRAY [1..Maxanzahl] OF Lastbild;
      Auflagerlinks,Auflagerrechts,      (* Groesse der Auflagerkraefte     *)
      Feldlaenge,                        (* Laenge des Traegers             *)
      MaxMoment,                         (* Groesse des maximalen Momentes  *)
      OrtMaxMoment,                      (* Ort des maximalen Momentes      *)
      dummy                   : REAL;
      Anzahl                  : INTEGER; (* tatsaechliche Anzahl der Lasten *)

(*$I eingabe.inc *)
(*$I berech.inc *)
(*$I bemess.inc *)

BEGIN (* EinfeldTraeger *)
  Eingabe;
  Auflagerlinks := 0; Auflagerrechts := 0;
  Auflagerkraefte (Auflagerlinks,Auflagerrechts);
  OrtMaxMoment := OrtMaximumMoment;
  Schnittkraft (OrtMaxMoment,Maxmoment,dummy);
  Ausgabe;
  Bemessung;
END. (* EinfeldTraeger *)
