{--------------------------------------------------}
{    gsxtype.pas - Pascal GSX Bibliothek:          }
{            Typen-Definitionen                    }
{--------------------------------------------------}

  Line_Types           = Solid..DashDotDot;
  Marker_Types         = Dot..Cross;
  Fill_Styles          = Hollow..Hatch;
  Color_Index          = Black..White;
  Draw_Modes           = Replace..Erase;
  Cursor_Operations    = Up..EraToLineEnd;
  Video_Attributes     = Reverse..Normal;
  Circle_Types         = Arc..PieSlice;
  Locator_Devices      = Keyboard..MouseJoystick;
  Input_Devices        = InputLocator..InputString;
  Input_Modes          = Request..Sample;

{ Die Groessen der folgenden Felder sind Funktions-
  und Anwendungsabhaengig. Sie wurden so gewaehlt,
  dass sie in den meisten Faellen ausreichen
  duerften.                                        }

  VDI_contrl    = ARRAY [1..10] OF INTEGER;
  VDI_intin     = ARRAY [1..255] OF INTEGER;
  VDI_intout    = ARRAY [1..45] OF INTEGER;
  VDI_ptsin     = ARRAY [1..100] OF INTEGER;
  VDI_ptsout    = ARRAY [1..100] OF INTEGER;

  VDI_STRING    = STRING[80];

{--------------------------------------------------}
             { Ende von gsxtype.pas }
