{---------------------------------------------------------------------------}
{                   gsxvdi.pas - Pascal GSX Bibliothek:                     }
{                  Schnittstelle GSX <-> Betriebssystem                     }
{---------------------------------------------------------------------------}
{ Hier fuer CP/M plus (3.x) in TURBO-Pascal.

  Implementationsabhaengigkeit:
     Der Parameterblock PB enthaelt die absoluten Adressen der GSX-Arrays.
     Hier werden diese mittels einer in der verwendeten Pascal-Version
     implementierten Adress-Funktion ermittelt und dem Integer-Feld PB zu-
     gewiesen (16-Bit-Adressen). Andere Moeglichkeiten: s. Begleitartikel.  }

PROCEDURE VDI_Call (VAR contrl: VDI_contrl;
                    VAR intin : VDI_intin;   VAR intout: VDI_intout;
                    VAR ptsin : VDI_ptsin;   VAR ptsout: VDI_ptsout);

CONST VDIFctNum = 115;

VAR PB: ARRAY [1..5] OF Integer;

BEGIN
  PB[1] := Addr(contrl);
  PB[2] := Addr(intin);     PB[3] := Addr(ptsin);
  PB[4] := Addr(intout);    PB[5] := Addr(ptsout);
  BDos(VDIFctNum, Addr(PB));
  VDI_Error := (contrl[3] <> 0);
END;

{---------------------------------------------------------------------------}
                         { Ende von gsxvdi.pas }
