/*

  ERATHO.C
  Sieb der Erathostenes: testet Schleifen, Array-Zugriffe, Grundrechenarten
                         "Naiver" Algorithmus !!!

*/

#include <stdio.h>

#define MAX 17000
#define MAXSQRT 130
#define FALSE 0
#define TRUE 1
#define MAXIT 10

char flag[MAX];

main()
{
    int i, j, count, iter;

    for(iter = 1; iter <= MAXIT; iter++){

        printf("\n\n !! Fuellen des Feldes !!\n\n");
        for(i = 0; i < MAX; flag[i++] = TRUE);

        printf("\n\n !! Eratho startet !!\n\n");
        for(i = 2; i <= MAXSQRT; i++)
            if (flag[i])
                for(j = 2; j < (MAX/i); j++)
                    flag[i*j] = FALSE;

        printf("\n\n !! Eratho fertig !!\n\n");
        for(i = 2,count = 0; i < MAX; i++)
            if (flag[i])
                count++;

        printf("\n\n ***** Durchgang %2d ***** ",
               "---> Eratho fand %5d Primzahlen. \n\n",iter,count);
    }
}




