
Program Network;

{$I COMPLEX.INC}

Var w,C,L,R,
    Zabs,phi   :Real;
    Z,ZC,ZL,ZR :Complex;

Begin

(* Einlesen der physikalischen Groessen *)

Write ('Frequenz der Wechselspannung (in Hertz):     w = '); ReadLn (w);
Write ('Kapazitaet des Kondensators (in Farad)       C = '); ReadLn (C);
Write ('Induktivitaet der Spule (in Henry):          L = '); ReadLn (L);
Write ('Ohmscher Widerstand (in Ohm)                 R = '); ReadLn (R);

(* Berechnung der komplexen Widerstaende *)

ZC := cinv (cval (0,w*C));
ZL := cval (0,w*L);
ZR := cval (R,0);

(* Auswertung der Gesamtimpedanz *)

Z := cinv (cadd (cinv(ZC),cinv(cadd(ZL,ZR))));

(* Zerlegung in Widerstand und Phasenverschiebung *)

polar (Z,Zabs,phi);
phi := phi * 180/pi;

WriteLn;
Write ('Gesamtimpedanz des Netzwerks (in Ohm):       Z = '); WriteLn (Zabs:7:3);
Write ('Phase zwischen Strom/Spannung (in Grad):   phi = '); WriteLn (phi:7:3);

End.