/********************************************************************
*  TITEL           :  Crypt                                         *
*                                                                   *
*  DATEI           :  system.c                                      *
*  VERSION         :  1.0                                           *
*  AUTOR           :  Joachim Eckart                                *
*  DATUM           :  11/86                                         *
********************************************************************/
#include     "crypt.h"

/***         Systemabhaengige Funktionen                         ***/

#if ST
cls()                     /* Bildschirm loeschen                   */
{
    putesc('E');
}
crs_off()                 /* Cursor aus                            */
{
    putesc('f');
}
crs_on()                  /* Cursor an                             */
{
    putesc('e');
}
rev_off()                 /* Reverse-Video aus                     */
{
    putesc('q');
}
rev_on()                  /* Reverse-Video an                      */
{
    putesc('p');
}
pos(x,y)                  /* Cursor in Spalte x Zeile y setzen     */
register int x,y;
{
    putesc('Y');
    gemdos(0x2,y+32);
    gemdos(0x2,x+32);
}
int  get_hidden()         /* Zeichen ohne Echo von Tastatur holen   */
{
    return( (int)(gemdos(0x8)) );
}
void put_s(s)             /* String auf Schirm ausgeben             */
register char *s;
{
    gemdos(0x9,s);
    gemdos(0x2,'\r');     /* mit CR abschliessen                    */
}
#endif

#if EOS
          /* Bildschirm loeschen ist original cls()                */

crs_off() {}              /* Cursor aus   nicht implementiert      */

crs_on()  {}              /* Cursor an    nicht implementiert      */

rev_off()                 /* Reverse-Video aus                     */
{
    chattrib(0);
}
rev_on()                  /* Reverse-Video an                      */
{
    chattrib(1);
}
pos(x,y)                  /* Cursor in Spalte x Zeile y setzen     */
register int x,y;
{
    gotoxy(x,y);
}
int  get_hidden()         /* Zeichen ohne Echo von Tastatur holen   */
{
    return(ci());
}
void put_s(s)             /* String auf Schirm ausgeben             */
register char *s;
{
    puts(s);
}
#endif

repair_scr()
{
#if ST
    crs_on();
    putesc('b');
    gemdos(0x2,1);              /* White on black .. falls bei      */
    putesc('c');                /* binaerer Ausgabe umgeschaltet    */
    gemdos(0x2,0);
#endif
}