{---------------------------------------------------------------------------}
{              Demonstration der GSX-Cell-Array-Funktion:                   }
{ Fuer das hier verwendete 'ColorIndexArray' muss der Typ 'VDI_intin' in    }
{ GSXTYPE.PAS wegen der Menge der Daten folgendermassen geaendert werden:   }
{                VDI_intin = ARRAY [1..1200] OF INTEGER;                    }
{---------------------------------------------------------------------------}

PROGRAM CellArrayDemo;

CONST
  {$I gsxconst.pas}
  CelCols = 60;                                   { unser Cell-Array hat 60 }
  CelRows = 20;                                   { Spalten und 20 Zeilen   }

TYPE
  {$I gsxtype.pas}

VAR
  {$I gsxvar.pas}
  CArray: VDI_intin;
  CDaten: TEXT;

{$I gsxvdi.pas}
{$I gsxlib1.pas}

{---------------------------------------------------------------------------}

PROCEDURE Read_CArray;

VAR i: INTEGER;

BEGIN
  Assign(CDaten, 'CELLDEMO.DAT');
  ReSet(CDaten);
  FOR i := 1 TO CelRows*CelCols DO
  BEGIN
    Read(CDaten, CArray[i]);
    IF (i MOD 30) = 0 THEN
    BEGIN
      ReadLn(CDaten);
      Write('.');
    END;
  END;
  WriteLn;  WriteLn;
END;

{---------------------------------------------------------------------------}

BEGIN
  WriteLn;  Write('Lese Daten des Cell-Arrays...');
  Read_CArray;
  Open_Workstation(Screen);
  IF CellArrays THEN
    BEGIN
      Enter_Graphics;
      Cell_Array( 1000,  1000,  4500,  3500, CArray,
                 CelRows, CelCols, CelCols, Replace);
      Cell_Array( 5000,  1000, 32000,  4000, CArray,
                 CelRows, CelCols, CelCols, Replace);
      Cell_Array( 2000,  7000,  6000, 32000, CArray,
                 CelRows, CelCols, CelCols, Replace);
      Cell_Array(18000, 20000, 28000, 27000, CArray,
                 CelRows, CelCols, CelCols, Replace);
      Cell_Array(12000, 12000, 19000, 15000, CArray,
                 CelRows, CelCols, CelCols, Replace);
    END
  ELSE
    Write('Geraet unterstuetzt keine Cell-Arrays !');
  REPEAT UNTIL KeyPressed;
  Close_Workstation;
END.
