(*-------------------------------------------------------------------------*)
(*                              LINE.PAS                                   *)
(*        Linie zeichnen mit Hilfe des mit Include spez. Algorithmus       *)
(*-------------------------------------------------------------------------*)

PROCEDURE Line (x1: x_Koord; y1: y_Koord; x2: x_Koord; y2: y_Koord);

VAR x1_sys, y1_sys, x2_sys, y2_sys: INTEGER;

BEGIN
  Pen_Xpos := x2;          (* Pos. des 'Stiftes' fuer rel. Zeichnen merken *)
  Pen_Ypos := y2;
                       (* Grafikkoordinaten in Systemkoordinaten umrechnen *)
  x1_sys := x1 + ScreenXmin_Sys;  y1_sys := y1 + ScreenYmin_Sys;
  x2_sys := x2 + ScreenXmin_Sys;  y2_sys := y2 + ScreenYmin_Sys;
  IF Origin_is_Top THEN     (* y-Koordinaten bei anderem Ursprung spiegeln *)
  BEGIN
    y1_sys := ScreenYmax_Sys - y1_sys;
    y2_sys := ScreenYmax_Sys - y2_sys;
  END;
  do_line(x1_sys, y1_sys, x2_sys, y2_sys);    (* schliessl. Linie zeichnen *)
END;

(*-------------------------------------------------------------------------*)
(*                        Ende von LINE.PAS                                *)
