(*-------------------------------------------------------------------------*)
(*                             MOIRE.PAS                                   *)
(*                    Demonstration der Kreisalgorithmen                   *)
(* Bildet durch Ueberlagerung von konzentrischen Kreisen Interferenzmuster *)
(*-------------------------------------------------------------------------*)

PROGRAM moire;

CONST
  (*$I GRAFCONS.PAS *)
  radius_schritt = 4;

TYPE
  (*$I GRAFTYPE.PAS *)

VAR
  (*$I GRAFVAR.PAS *)
  i : INTEGER;

(*$I GRAFSYS.PAS *)   (* Grafik Initialisierungen                          *)
(*$I BRESENH.PAS *)   (* Algorithmus, bei der Verwendung von CIRCDRAW sind
                         vor dieser Include-Anweisung mit selbiger die Da-
                         teien INTDDA, LINE und RELGRAF einzubinden!!      *)
(*$I CIRCLE.PAS *)

BEGIN
  Enter_Graphic;
  FOR i := 1 TO Pred(ScreenYmax) DIV radius_schritt DO
    circle(ScreenXmax DIV 2 - 5, ScreenYmax DIV 2, i*radius_schritt);
  FOR i := 1 TO Pred(ScreenYmax) DIV radius_schritt DO
    circle(ScreenXmax DIV 2 + 5, ScreenYmax DIV 2, i*radius_schritt);
  REPEAT UNTIL KeyPressed;
  Exit_Graphic;
END.

(*-------------------------------------------------------------------------*)
(*                         Ende von MOIRE.PAS                              *)
