(*-------------------------------------------------------------------------*)
(*                          FILLDEM1.PAS                                   *)
(*              Demonstriert das Flaechenfuellen                           *)
(*-------------------------------------------------------------------------*)
PROGRAM FillDem1;

CONST
  (*$I GRAFCONS.PAS *)

TYPE
  (*$I GRAFTYPE.PAS *)

VAR
  (*$I GRAFVAR.PAS  *)
  Feld: Polygon;

(*$I GRAPH.P              s. POLYDEMO *)
(*$I GRAFSYS.PAS  *)
(*$I INTDDA.PAS   *)
(*$I LINE.PAS     *)
(*$I RELGRAF.PAS  *)
(*$I POLYLINE.PAS *)
(*$I FLOODFIL.PAS   bzw. FLOODITA.PAS *)

BEGIN
  Enter_Graphic;
  Feld[1].x := ScreenXmax DIV 2;     (* Die folgenden Variablenzuweisungen *)
  Feld[1].y := ScreenYmax DIV 4;     (* definieren ein Dreieck.            *)
  Feld[2].x := ScreenXmax DIV 5 * 3;
  Feld[2].y := ScreenYmax DIV 6 * 3;
  Feld[3].x := ScreenXmax DIV 5 * 2;
  Feld[3].y := Feld[2].y;
  Feld[4].x := Feld[1].x;          (* Das Dreieck muss geschlossen werden, *)
  Feld[4].y := Feld[1].y;          (* daher der 4. Punkt, der sich mit dem *)
                                   (* ersten deckt.                        *)
  PolyLine(Feld, 4);               (* Dreieck zeichnen... und fuellen!     *)
  Fill(ScreenXmax DIV 2, ScreenYmax DIV 3, Last_Color_Value);
  REPEAT UNTIL KeyPressed;
  Exit_Graphic
END.

(*-------------------------------------------------------------------------*)
(*                             Ende FILLDEMO.PAS                           *)