(* ---------------------------------------------------------------- *)
(*                         ASTROTYP.PAS                             *)
(*                     ein paar Astro-Typen:                        *)
(* ---------------------------------------------------------------- *)

   Astro_String = STRING[20];

   Astro_Datum  = RECORD
                    Tag  : 1..31;
                    Monat: 1..12;
                    Jahr : Jul_Ref_Jahr..3000;
                  END;

   Astro_Zeit   = RECORD
                    Stunden : 0..23;
                    Minuten : 0..59;
                    Sekunden: 0..59;
                  END;

   Astro_Winkel = RECORD
                    Grad: 0..359;
                    Min : 0..59;
                    Sek : 0..59;
                  END;

   Astro_OrtPtr = ^Astro_Ort;
   Astro_Ort    = RECORD
                    Ortsname    : Astro_String;
                    Laengengrad : REAL;
                    Breitengrad : REAL;
                    naechster   : Astro_OrtPtr;
                  END;

   Astro_Tage   = 0..6;

(* ---------------------------------------------------------------- *)
(*                       Ende von ASTROTYP.PAS                      *)
