(***************************************************************************)
(*                          AWARI.PAS                                      *)
(*   DIESE DATEI ENTHAELT DEN VEREINBARUNGSTEIL UND DAS HAUPTPROGRAMM      *)
(***************************************************************************)

PROGRAM awari (Input, Output);

CONST max    = 3;  (* Anzahl der Steine pro Feld zum Zeitpunkt Spielbeginn *)

TYPE  feld   = ARRAY [0 .. 13] OF INTEGER; (* Spielfeld-Definition         *)

VAR  stapel : ARRAY [1 .. 14] OF feld;    (* Stellungsspeicher f. Analyse  *)
     wert   : ARRAY [1 .. 14] OF INTEGER; (* Bewertungsspeicher f. Analyse *)
     spiel  : feld;                       (* Spielfeld                     *)
     stief  : INTEGER;                    (* Suchtiefe in Halbzuegen       *)
     tiefe  : INTEGER;                    (* Objektive Analysetiefe        *)
     stark  : INTEGER;                    (* Spielstaerke in Halbz.        *)
     anfang : CHAR;                       (* Spiel-Beginner                *)
     weiter : BOOLEAN;                    (* Speicher fuer Partieende      *)
     fertig : BOOLEAN;                    (* Speicher fuer Programmende    *)
     best_1 : INTEGER;                    (* Bester berechn. erster Zug    *)
     best_2 : INTEGER;                    (* Bester berechn. zweiter Zug   *)
     try_1  : INTEGER;                    (* Potentieller bester 1. Zug    *)
     try_2  : INTEGER;                    (* Potentieller bester 2. Zug    *)
     nummer : INTEGER;                    (* Zugzaehler f. Endspielerkenn. *)
     zahl   : INTEGER;                    (* Anzahl der Steine im Spiel    *)

(*$I AWARINTR.INC *)
{$I AWARINIT.INC }
{$I AWARCOMP.INC }
{$I AWARMANG.INC }

BEGIN
  introduction;
  REPEAT
    initialisieren;
    IF  anfang = 'M'  THEN  m_zug;
    REPEAT
      c_zug;
      IF  weiter  THEN  m_zug
    UNTIL  NOT weiter;
    spielende
  UNTIL  fertig;
  ClrScr
END.
