(*-------------------------------------------------------------------------*)
(*                             DFMBNR.INC                                  *)
(*              Mailbox-Telephonregister des DFUE-Programm                 *)

OVERLAY FUNCTION SenkrechtMenue: INTEGER;

CONST NrMailBoxen = 23;

VAR i, SenkWahl, AltWahl : INTEGER;
    SenkZeichen : CHAR;

BEGIN
  ClrScr;                                        (* Bildschirm loeschen *)
  FOR i := 1 TO NrMailBoxen DO WriteLn(MBNr[i]); (* Zeilen ausgeben     *)
  GotoXY(1,25);
  Write('Mit CURSORTASTEN aussuchen, RETURN waehlt an');
  (* Initialisierung der Wahl-Variablen *)
  SenkWahl:=1;
  AltWahl:=2;
  REPEAT
    (* Bildschirm aktualisieren *)
    FOR i := 1 TO NrMailBoxen DO BEGIN
      (* Aktuelle Zeile invers *)
      IF i = SenkWahl THEN BEGIN
        GotoXY(1,i);
        WriteLn(INV_EIN,MBNr[i],INV_AUS)
      END;
      (* Vorherige aktuelle Zeile wieder normal *)
      IF i = AltWahl THEN BEGIN
        GotoXY(1,i);
        WriteLn(MBNr[i])
      END
    END;
    (* Tastatur abfragen *)
    REPEAT
      SenkZeichen := GetKey
    UNTIL SenkZeichen IN [CURSOR_HOCH,CURSOR_RUNTER,RETURN];
    (* Zeichen auswerten *)
    CASE SenkZeichen OF
      CURSOR_HOCH : BEGIN
                      AltWahl := SenkWahl;
                      SenkWahl := SenkWahl - 1
                    END;
      CURSOR_RUNTER : BEGIN
                        AltWahl := SenkWahl;
                        SenkWahl := SenkWahl + 1
                      END;
      RETURN : ;
    END;
    (* "Wrap-around" der Selektion *)
    IF SenkWahl = 0 THEN
      SenkWahl := NrMailBoxen;
    IF SenkWahl = NrMailBoxen + 1 THEN
      SenkWahl := 1
  UNTIL SenkZeichen = RETURN;
  SenkrechtMenue := SenkWahl
END;



OVERLAY PROCEDURE Mailboxnummern;

VAR MailBox : INTEGER;
    Hilf : CHAR;

BEGIN
  ClrScr;           (* Bildschirm loeschen *)
  (* Feld mit Menuezeilen belegen *)
  MBNr[1] := 'WDR-COMPUTERCLUB   * 0221/371076    ** 81N * 00-24H';
  MBNr[2] := 'DATA-BECKER        * 0211/340071    ** 71E * 00-24H';
  MBNr[3] := 'R-CP/M             * 0211/324517    ** 81N * 00-24H';
  MBNr[4] := 'MCS                * 040/2512371    ** 81N * 00-24H';
  MBNr[5] := 'RBBS               * 0431/336038    ** 81N * 00-24H';
  MBNr[6] := 'TEDAS1             * 089/596422     ** 81N * 00-24H';
  MBNr[7] := 'TEDAS2             * 089/598423     ** 81N * 00-24H';
  MBNr[8] := 'GES/GRAF           * 0831/69330     ** 81N * 00-24H';
  MBNr[9] := 'COMPUCAMP          * 05931/18948    ** 81N * 00-24H';
  MBNr[10] := 'NCS KIEL           * 04348/7513     ** 81N * 00-24H';
  MBNr[11] := 'EPSON              * 0211/5047865   ** 81N * 00-24H';
  MBNr[12] := 'MAGIC MOUNTAIN     * 02236/63371    ** 72N * 00-24H';
  MBNr[13] := 'CCC-BOX            * 06434/6291     ** 81N * 00-24H';
  MBNr[14] := 'COMMODORE          * 069/6638191    ** 81N * 00-24H';
  MBNr[15] := 'INFOBOX  PASSAU    * 08531/69330    ** 81N * 00-24H';
  MBNr[16] := 'THOWO BOX          * 030/667085     ** 81N * 00-24H';
  MBNr[17] := 'DARC               * 0561/498669    ** 81N * 00-24H';
  MBNr[18] := 'FSS-INFOBOX        * 089/596465     ** 81N * 00-24H';
  MBNr[19] := 'VOLLRATH           * 0209/271666    ** 81N * 00-24H';
  MBNr[20] := 'C.L.I.N.C.H        * 040/6323517    ** 71N * 00-24H';
  MBNr[21] := 'MBS                * 040/2993461    ** 81N * 00-24H';
  MBNr[22] := 'TORNADO            * 040/5277016    ** 81N * 00-24H';
  MBNr[23] := 'R-A-M              * 040/8802383    ** 81N * 00-24H';
  MailBox := SenkrechtMenue;
  ClrScr;
  WriteLn(MBNr[MailBox]);
  WriteLn;
  Param[1] := 1;    (* Immer 300 Baud ! *)
  (* Anzahl Datenbits aus Zeile "herauspicken" *)
  Hilf := Copy(MBNr[MailBox],(Pos('** ',MBNr[mailbox])+3),1);
  CASE Hilf OF
    '8'  : Param[2] := 1;
    '7'  : Param[2] := 2
  END;
  (* Anzahl Stopbits aus Zeile "herauspicken" *)
  Hilf := Copy(MBNr[MailBox],(Pos('** ',MBNr[mailbox])+4),1);
  CASE Hilf OF
    '1'  : Param[3] := 1;
    '2'  : Param[3] := 2
  END;
  (* Paritaet aus Zeile "herauspicken" *)
  Hilf := Copy(MBNr[mailbox],(Pos('** ',MBNr[mailbox])+5),1);
  CASE Hilf OF
    'N'  : Param[4] := 1;
    'E'  : Param[4] := 2;
    'O'  : Param[4] := 3
  END;
  (* Vollduplex, kein Linefeed, Delay 0 *)
  Param[5] := 1;
  Param[6] := 1;
  Param[7] := 1;
  Setze_Parameter;
  WriteLn('Parameter sind gesetzt');
  WriteLn('Waehlen Sie jetzt bitte die Telefonnummer, dann Taste druecken !');
  REPEAT UNTIL KeyPressed;
  Online
END;

(*-------------------------------------------------------------------------*)
(*                           Ende DFMBNR.INC                               *)