(* ----------------------------------------------------------------------- *)
(*                           PDCONST.PAS                                   *)
(*              Systemabhaengige und PULLDOWN-Konstanten                   *)

(* -----------------      Hardwareabhaengige Groessen    ----------------- *)
                {  hier speziell fuer IBM-Kompatible Rechner:  }
{ Konstanten und Routinen zur Bildschirmspeicher-Verwaltung:
  Beginn des Speichers bei Color-Grafikkarte:  $B800:0000
                          Monochrome-Adapter:  $B000:0000 }
               ScreenSeg   = $B800;
               ScreenOfs   = $0000;
               ScreenLen   = $1000;  { Monochrome-Adapter: $2000 }
{ Definition der in "Pulldown" verwendeten Steuercodes, diese muessen aus
  Konstanten vom Typ "CHAR" bestehen; erzeugen die gewuenschten Tasten
  laengere Codes (z.B. Funktions- und Cursor-Tasten bei PC's),  so kann
  eine Uebersetzung in der Prozedur "ReadChar" erfolgen: }
               CrsLeft     = ^S;        (*  Pfeiltasten:  links   *)
               CrsRight    = ^D;        (*       -        rechts  *)
               CrsUp       = ^E;        (*       -        oben    *)
               CrsDown     = ^X;        (*       -        unten   *)
               ESC         = ^[;        (*  Escape-Steuerzeichen  *)
               CR          = ^M;        (*  Carriage-Return-Code  *)
{ Zeichen zum Zeichnen des Rahmens um ein Menue: }
               LeftTop     = #201;      RightTop    = #187;
               LeftBottom  = #200;      RightBottom = #188;
               Horizontal  = #205;      Vertical    = #186;
(* -----------------      PULLDOWN-MENUE     Groessen:   ----------------- *)
      MaxItems   =  6;                (* maximale Anzahl von Menuepunkten  *)
      ItemLength = 15;               (* maximale Laenge eines Menuepunktes *)
(* ----------------------------------------------------------------------- *)
(*                         Ende von PDCONST.PAS                            *)
