(*--------------------------------------------------------------*)
(*                       BDOSBIOS.PAS                           *)
(* Funktionen zum BDOS/BIOS-Aufruf mit JRT-Pascal 2.0 auf CP/M  *)

FUNCTION BDOS(Fkt, Par : INTEGER) : INTEGER;

TYPE Register = RECORD
                  CASE INTEGER OF
                    1 : (Flag,A,C,B,E,D,L,H : CHAR);
                    2 : (AF,BC,DE,HL : INTEGER);
                  END;

VAR BDOSReg, ResReg : Register;

BEGIN
  BDOSReg.C := Chr(Fkt);
  BDOSReg.DE := Par;
  Call(5,BDOSReg,ResReg);
  BDOS := Ord(ResReg.A);
END;



FUNCTION Bios(Fkt, Par : INTEGER) : INTEGER;

TYPE BIOSPB = RECORD
                Func, A : CHAR;
                BC, DE, HL : INTEGER;
              END;
     Register = RECORD
                  CASE INTEGER OF
                    1 : (Flag,A,C,B,E,D,L,H : CHAR);
                    2 : (AF,BC,DE,HL : INTEGER);
                  END;

VAR BIOSReg : BIOSPB;
    BDOSReg,
    ResReg  : Register;

BEGIN
  BIOSReg.Func := Chr(Fkt);
  BIOSReg.BC := Par;
  BDOSReg.BC := 50;
  BDOSReg.DE := Addr(BIOSReg);
  Call(5,BDOSReg,ResReg);
  Bios := Ord(ResReg.A);
END;

(*------------------------------------------------------------*)
(*                    Ende BDOSBIOS.PAS                       *)


