{---------------------------------------------------------------------------}
{ Programm SeqDat: erzeugt ein seq. Datei mit den Zahlen von 1..100,
                   speichert und liest sie wieder.
                   Zum Schreiben und Lesen der Datei werden die Prozeduren
                   Put und Get benutzt!
    Pascal-System: Pascal ST+ / Atari ST                                    }

PROGRAM seq_dat;

VAR    i: INTEGER;                                         { Laufvariabele  }
       seq_dat: FILE OF INTEGER;                           { Dateivariabele }

{---------------------------------------------------------------------------}
{            schreibt die Zahlen 1..100 in die seq. Datei:                  }

PROCEDURE schreibe;

VAR i: INTEGER;

BEGIN
  ReWrite(seq_dat, 'seqdat.seq');             { Datei neu erzeugen          }
  FOR i := 1 TO 100 DO                        { Zahlen erzeugen             }
  BEGIN
    seq_dat^ := i;                            { Datei-Puffer mit Zahl laden }
    Put(seq_dat);                             { und in Datei schreiben      }
  END;
END;

{---------------------------------------------------------------------------}
{                   liest die Zahlen und gibt sie aus:                      }

PROCEDURE lese;

VAR i: INTEGER;

BEGIN
  ReSet(seq_dat, 'seqdat.seq');            { Datei zum lesen oeffnen,
                                             erste Zahl ist in Datei-Puffer }
  REPEAT
    i := seq_dat^;         { Inhalt des Datei-Puffers in Variabele kopieren }
    WriteLn(i);
    Get(seq_dat);                                     { naechste Zahl lesen }
  UNTIL Eof(seq_dat);                                 { bis Dateiende       }
END;

{-------------------------------- Main -------------------------------------}

BEGIN
  schreibe;                                                { erzeuge Datei  }
  lese;                                                    { Datei ausgeben }
END.
