{-----------------------------------------------------------------------}
{                gsxvar.pas - Pascal GSX Bibliothek:                    }
{                    Variablen-Deklarationen                            }
{-----------------------------------------------------------------------}

{ GSX-Errorflag: ist TRUE, wenn bei einer
  GSX-Operation ein Fehler auftritt:            }

  VDI_Error: BOOLEAN;

  contrl   : VDI_contrl;
  intin    : VDI_intin;
  intout   : VDI_intout;
  ptsin    : VDI_ptsin;
  ptsout   : VDI_ptsout;

{ Die folgenden Variablen enthalten nach Open_Workstation Informationen
  ueber das eroeffnete Geraet:                                          }

  Scaling,                   { Exakt skalierendes Ausgabegeraet ?       }
  ColorDevice,               { Farbfaehig ?                             }
  TextRotation,              { Text kann gedreht werden ?               }
  AreaFill,                  { Flaechen koennen gefuellt werden ?       }
  CellArrays  : BOOLEAN;     { Zeichenzellen-Raster-Fuellung moglich ?  }

  HRes,                    { hor. Aufloesung, fuer Plotter undefiniert. }
  VRes,                    { ver. Aufloesung                            }
  PixWidth, PixHeight,       { Abmessung eines Pixels in 1/1000 mm      }
  CharHeights,               { Anzahl verschiedener Zeichenhoehen,      }
                             { 0 = kontinuierlich varierbar.            }
  Lines, LineWidths,          { Anzahl Linienarten/Linienbreiten        }
  Markers, MarkerSizes,       {   "    Markierungsarten/-groessen       }
  Fonts, Patterns,            {   "    Schriftarten/Fuellmuster         }
  HatchStyles, Colors,        {   "    Schraffuren/vordefinierte Farben }
  GDPs,                       {   "    ZeichenMakros: Kreis,Balken etc. }
  ColorsAvail,                {   "    moeglicher Farben                }
  InputLocators,              {   "    Zeiger (z.B. Joystick)           }
  InputValuators,             {   "    Regler (z.B. Paddles)            }
  InputChoices,               {   "    Funktionstasten                  }
  InputStrings,               {   "    Text-Eingabe (z.B. Tastatur)     }
  MinCharHeight, MaxCharHeight,      { minimale/maximale  Zeichenhoehe  }
  MinLineWidth, MaxLineWidth,        { minimale/maximale Zeilenbreite   }
  MinMarkHeight, MaxMarkHeight,      { minimale/maximale Markiererhoehe }
  WorkstationType             :INTEGER;

{-----------------------------------------------------------------------}
                        { Ende von gsxvar.pas }