(* ------------------------------------------------------------------------ *)
(*                   Demonstration von MATRIX.INC                           *)
(*                        Loesung eines LGS                                 *)
(* ------------------------------------------------------------------------ *)

PROGRAM Solving_LGS_by_Inverse;

CONST MaxIndex = 5;

{$I MATRIX.INC}

VAR A,B: Matrix;
    i,j: Range;
    Key: CHAR;

BEGIN
  ClrScr;
  WriteLn('Eingabe der Koeffizientenmatrix:'); WriteLn;
  ReadMat('CON:',A);
  Inverse(A);
  B.Rows := A.Rows;
  B.Columns := 1;
  REPEAT
    WriteLn;
    WriteLn('Eingabe der rechten Seite:'); WriteLn;
    FOR i := 1 TO A.Rows DO
    BEGIN
      Write('b[', i, '] = ');
      ReadLn(B.Coeff[i,1]);
    END;
    MultMat(A, B, B);
    WriteLn('Loesung des Systems:');
    WriteMat('CON:', B, 10, 4); WriteLn;
    Write('Abbruch mit <E>, sonst weitere Berechnung...');
    ReadLn(Key);
  UNTIL Key IN ['E','e'];
END.
