/*

  SIEVE.C
  Sieb der Erathostenes: testet Schleifen und Array-Zugriffe
                         Auf Additionen reduzierter Algorithmus !!!

*/

#include <stdio.h>

#define SIZE 8190
#define FALSE 0
#define TRUE 1
#define NTIMES 10

char flag[SIZE + 1];

main()
{
    int i, j, k, count, prime;

    printf("%d iterations: ",NTIMES);

    for(i = 1; i <= NTIMES; i++) {
        count = 0;
        for(j = 0; j <= SIZE; j++)
            flag[j] = FALSE;
        for(j = 0; j <= SIZE; j++){
            if (flag[j]) {
                prime = j + j + 3;
                for(k = j + prime; k <= SIZE; k += prime)
                    flag[k] = FALSE;
                count++;
            }
        }
    }
    printf("Number of primes : %d",count);
}


