/********************************************************************
*  TITEL           :  Crypt                                         *
*                                                                   *
*  DATEI           :  crypt.h                                       *
*  VERSION         :  1.0                                           *
*  AUTOR           :  Joachim Eckart                                *
*  DATUM           :  11/86                                         *
********************************************************************/

#define   ST  1          /* Zielrechner Atari ST                   */
                         /* mit Megamax C-Compiler                 */

#define   EOS 0          /* Zielrechner Sharp MZ5600 unter EOS16   */
                         /* mit Desmet C-Compiler                  */

/***         Systemabhaengige Routinen                           ***/

#if ST
extern  long gemdos();
#define putesc(c) gemdos(0x2,ESC),gemdos(0x2,c) /*  putesc ist     */
                     /* Makro und gibt die Zeichen ESC + c aus     */
#endif

#if EOS
#define stdin STDIN      /* in stdio.h ist nur STDIN definiert     */
#endif

/***            Konstantendefinition                             ***/
#define   MAXKEYL  80    /* max. Schluessellaenge                  */
#define   MAXSIZE  32767 /* maximale Dateigroesse                  */
#if ST
#define   PMODE    8194  /* mode fuer open :in binaer Modus        */
#endif
#if EOS
#define   PMODE    0     /* open immer binaer unter EOS            */
#endif
#define   void     int   /* die meisten Compiler kennen diesen     */
                         /* Datentyp nicht -- aber in Zukunft ?    */
#define   ESC      0x1b  /* Escape Code                            */

/***            Deklaration externer Funktionen                  ***/
/*  ist fuer int bzw. void nicht zwingend , aber sauberer          */

extern    void cls();
extern    void crs_off();
extern    void crs_on();
extern    void rev_off();
extern    void rev_on();
extern    void pos();
extern    void put_s();
extern    int  get_hidden();
extern    void repair_scr();
extern    char *malloc();    /* Unix Fkt.- liefert Zeiger auf char */
