{ Verhalten des nichtlinearen Wachstums! }

PROGRAM feigenbaum;

CONST
  xres = 640;    { Anzahl Punkte auf X-Achse }
  yres = 200;    { Anzahl Punkte auf Y-Achse }
  tage = 30;
  max  = 1000;
  xmax = 1500;
  xmin = 0;
  rmin = 1.9;
  rmax = 3;

VAR
  n, j, rn: INTEGER;
  x, dr, r, mas_x: REAL;

{---------------------------------------------------------}

FUNCTION xkoor (xwert: REAL): INTEGER;

BEGIN
  xkoor := yres - Round((xwert - xmin) * mas_x);
END;

{---------------------------------------------------------}

BEGIN
  ClrScr;
  HiRes;
  mas_x := yres / (xmax-xmin);
  dr := (rmax - rmin) / a;
  FOR rn := 0 TO xres-1 DO
  BEGIN
    r := rmin + dr * rn;
    x := 1;
    FOR j := 0 TO 1 DO
      FOR n := 1 TO tage DO
      BEGIN
        x := x + x * r * (1 - x / max);
        Plot (rn, xkoor(x), j);
      END;
  END;
  REPEAT UNTIL KeyPressed;
END.
