{ Verhalten des nichtlinearen Wachstums!}

PROGRAM feige;

CONST
  xres = 640;  { Anzahl Punkte auf X-Achse }
  yres = 200;  { Anzahl Punkte auf Y-Achse }
  tage = 60;
  max  = 1000; { Obergrenze Wachstum }
  r    = 0.2;  { Wachstumsrate }

VAR
  n,
  xk, xk_alt: INTEGER;
   x, dtage : REAL;

{---------------------------------------------------------}
{ Umrechnung in Bildschirmkoordinaten.                    }

FUNCTION xkoor (xwert: REAL): INTEGER;

BEGIN
  xkoor := yres - Round(xwert * yres / max * 0.7);
END;

{---------------------------------------------------------}

BEGIN
  ClrScr;
  HiRes;
  dtage := xres / tage;
  x := 1;                        { Startwert eine Seerose }
  xk := xkoor(x);            { Koordinate des Startwertes }
  FOR n := 1 TO tage DO
  BEGIN
    xk_alt := xk;
    x := x + x * r;       { spaeter anfuegen: *(1-x/max); }
    xk := xkoor(x);
    Draw(Round((n-1)*dtage), xk_alt, round(n*dtage), xk, 1)
  END;
  REPEAT UNTIL KeyPressed;       { auf Tastendruck warten }
END.
