(*
Title   : Einfach (Uebungsprogramm fuer PASCAL-Magazin)
LastEdit: 1.12.86.
Author  : Joerg BEYER, Tuebingen
System  : LOGITECH MODULA-2/86
*)

IMPLEMENTATION MODULE Einfach;

FROM InOut IMPORT WriteString,
                  Read,
                  ReadCard,
                  WriteCard,
                  WriteLn;

CONST
      TerminalZeilen = 25;


  PROCEDURE FrageJaNein (text: ARRAY OF CHAR): BOOLEAN;

    VAR y       : CHAR;
        Antwort : BOOLEAN;

  BEGIN
    y := "Z";
    WHILE NOT ((y = "J") OR (y = "j") OR (y = "N") OR (y = "n")) DO
      WriteString(text);
      WriteString(" J/N ");
      Read(y);
      WriteLn;
      IF ((y = "J") OR (y ="j")) THEN
        Antwort := TRUE
      ELSE
        Antwort := FALSE;
      END; (* IF *)
    END; (* DO *)
    RETURN Antwort;
  END FrageJaNein;


  PROCEDURE Eingabe (Text: ARRAY OF CHAR): CARDINAL;
  (* Uebernimmt Text, Druckt ihn aus erwartet Input einer Cardinal-Zahl
     und gibt diese Zurueck *)

  VAR
     X    : CARDINAL;

  BEGIN
    WriteString(Text);
    WriteString('...');
    ReadCard   (X);
    WriteLn;
    RETURN X;
  END Eingabe;


  PROCEDURE Ausgabe (Text: ARRAY OF CHAR; Zahl: CARDINAL);
  (* Gibt den Text und im Anschluss daran die Zahl auf dem angewaehlten
     Medium aus *)

  BEGIN
    WriteString(Text);
    WriteCard  (Zahl,3);
    WriteLn;
  END Ausgabe;


  PROCEDURE ClrScr;

  VAR i : CARDINAL;

  BEGIN
    FOR i := 1 TO TerminalZeilen DO
        WriteLn
    END;
  END ClrScr;

END Einfach.
