(*-------------------------------------------------------------------------*)
(*                             GPLOTTYP.PAS                                *)
(*             Typendefinitionen fuer den Plottersimulator                 *)
(*-------------------------------------------------------------------------*)

  GPfName    = STRING[14];                (* Dateiname der Pufferdatei     *)

  (* je nach Pascal-Implementation kann (muss) fuer 'bs' im Record 'GP-
     element der Typ CARDINAL oder WORD verwendet werden. Turbo-Pascal
     bereitet bei Zuweisungen an INTEGER von Hex.-Werten > MaxInt keine
     Schwierigkeiten. Bei Implementationen mit LONG_INTEGERn kann mit
     'TYPE word = 0..65535' dieser Typ vereinbart werden. Auch kann
     LONG_INTEGER bei entspr. Aenderung des Records und der Prozeduren
     IN GPLOTSYS.PAS direkt verwendet werden, wodurch weniger externe
     Pufferzeilen benoetigt werden und das Ganze ein wenig schneller wird. *)

  GPelement  = RECORD                     (* ein Element einer Pufferzeile *)
                 CASE BOOLEAN OF          (* s. o.                         *)
                   TRUE : (bs: INTEGER);             (* fuer's plotten     *)
                   FALSE: (cc: ARRAY[0..1] OF CHAR); (* fuer den Drucker   *)
               END;

  GPpZeile   = ARRAY[GPXmin_Sys..GPXmax_Sys] OF GPelement;
                                                       (* eine Pufferzeile *)

  GPModes    = (Setzen,Loeschen,Invertieren); (* Zeichen-Modes d. Plotters *)

(*-------------------------------------------------------------------------*)
(*                        Ende von GPLOTTYP.PAS                            *)
