(*-------------------------------------------------------------------------*)
(*                              RELGRAF.PAS                                *)
(*      Funktionen zum relativen u. absoluten Zeichnen bezueglich          *)
(*                           der Siftposition                              *)
(*-------------------------------------------------------------------------*)
(*                      relative Bewegung des Stift:                       *)

PROCEDURE mover (x, y: INTEGER);

BEGIN
  Pen_Xpos := Pen_Xpos + x;  Pen_Ypos := Pen_Ypos + y;
END;

(*-------------------------------------------------------------------------*)
(*                          relatives Zeichnen:                            *)

PROCEDURE liner (x, y: INTEGER);

BEGIN
  Line(Pen_Xpos, Pen_Ypos, Pen_Xpos + x, Pen_Ypos + y);
END;

(*-------------------------------------------------------------------------*)
(*                       relatives Punktesetzen:                           *)

PROCEDURE pointr (x, y: INTEGER);

BEGIN
  Pen_Xpos := Pen_Xpos + x;  Pen_Ypos := Pen_Ypos + y;
  point(Pen_Xpos, Pen_Ypos);
END;

(*-------------------------------------------------------------------------*)
(*                   Bewegung zu absoluter Position:                       *)

PROCEDURE movea (x, y: INTEGER);

BEGIN
  Pen_Xpos := x;   Pen_Ypos := y;
END;

(*-------------------------------------------------------------------------*)
(*          Zeichnen von Stiftposition zu absoluter Position:              *)

PROCEDURE linea (x, y: INTEGER);

BEGIN
  Line(Pen_Xpos, Pen_Ypos, x, y);
END;

(*-------------------------------------------------------------------------*)
(*                        Ende von RELGRAF.PAS                             *)
