{---------------------------------------------------------------------------}
{ CP/M-Directory auf Bildschirm ausgeben. Moegl. Erweiterungen der Prozedur
  s. Begleittext.
  Pascal-System: Turbo Pascal 3.0   Betriebssystem: CP/M 3.0                }

PROCEDURE TinyDir;

VAR FCB : ARRAY[0..35] OF CHAR;                { File Control Block         }
    DMA : ARRAY[0..3,0..31] OF CHAR;           { Direct Memory Access Array }
    i, x: BYTE;                                { Hilfsvariablen             }
    s   : STRING[1];                           { Eingabe-String             }

BEGIN
  BDOS(26, ADDR(DMA));                        { DMA-Adresse setzen          }
  WRITE('Drive: '); READLN(S);                { Drive-Bezeichnung abfragen  }
  FCB := '-???????????                        ';     { FCB setzen, 36 Bytes }
  IF s <> '' THEN
    FCB[0] := s[1]                            { Drive-Bezeichnung einsetzen }
  ELSE
    FCB[0] := '@';                             { leer fuer default Drive    }
  x := BDOS(17, ADDR(FCB));                    { Nach erstem Eintrag suchen }
  IF x < 4 THEN
    FOR i:= 1 TO 11 DO WRITE(DMA[x,i])
  ELSE
    WRITE('No File');
  WRITELN;
  WHILE x < 4 DO
  BEGIN
    x := BDOS(18);                      { Nach weiteren Eintragungen suchen }
    IF x < 4 THEN
      FOR i := 1 TO 11 DO WRITE(DMA[x,i]);
    WRITELN;
  END;
END;

{---------------------------------------------------------------------------}
