(*-------------------------------------------------------------------------*)
(*                            FILLDEM2.PAS                                 *)
(*                 Demonstriert den Allround-Polygonfill                   *)
(*-------------------------------------------------------------------------*)
PROGRAM FillDem2;

CONST
  (*$I GRAFCONS.PAS *)

TYPE
  (*$I GRAFTYPE.PAS *)

VAR
  (*$I GRAFVAR.PAS  *)
  Feld: Polygon;
  i, j, k, n : INTEGER;
  Kreuz: Pattern_;                                    (* fuer Pattern-Fill *)

(*$I GRAPH.P         s. POLYDEMO.PAS *)
(*$I GRAFSYS.PAS  *)
(*$I INTDDA.PAS   *)
(*$I LINE.PAS     *)
(*$I RELGRAF.PAS  *)
(*$I POLYLINE.PAS *)
(*$I POLYFILL.PAS    bzw. POLYFILP.PAS *)

BEGIN
                       (* fuer Pattern-Fill ein Kreuz als Muster erzeugen: *)
  FOR i := 0 TO PatternSize DO
    FOR j := 0 TO PatternSize DO
      Kreuz[i,j] := ((i = j) OR (i + j = PatternSize));
  FOR j := 1 TO 3 DO
  BEGIN                              (* drei verschieden Polygone zeichnen *)
    n := Random(PolyMax - 1) + 1;
    FOR i := 1 TO n DO
    BEGIN
      Feld[i].x := Random(ScreenXmax - 1) + 1;
      Feld[i].y := Random(ScreenYmax - 1) + 1
    END;
    Enter_Graphic;
    PolyFill(Feld, n);       (* bzw. PolyFill(Feld, n, Kreuz); mit Pattern *)
  END;
  REPEAT UNTIL KeyPressed;
  Exit_Graphic
END.

(*-------------------------------------------------------------------------*)
(*                      Ende FILLDEM2.PAS                                  *)