(***************************************************************************)
(*                         AWARINIT.INC                                    *)
(*    DIESE INCLUDE-DATEI ENTHAELT DIE INIT. DES SPIELES UND SCREENS       *)
(***************************************************************************)

PROCEDURE  screen_init;

   VAR  index                   : INTEGER;
        oben,  mitte,  unten    : STRING [5];
        hoben,  hmitte,  hunten : STRING [6];

   BEGIN
     (*   Die Strings fuer den Bildschirmaufbau werden initialisiert:  *)
     oben   := '+---+';
     mitte  := '! 3 !';
     unten  := '+---+';
     hoben  := '+----+';
     hmitte := '!  0 !';
     hunten := '+----+';
     (*   Der Bildschirm wird aufgebaut:  *)
     ClrScr;  GotoXY(6,3);
     Write('                       ');
     Write('                       ');
     Write('                       ');
     GotoXY(6,4);
     Write('              6       5');
     Write('       4       3       ');
     Write('2       1              ');
     GotoXY(6,5);  Write('            ');
     FOR  index := 1  TO  6  DO  Write(oben, '   ');
     Write('         ');  GotoXY(6,6);  Write('            ');
     FOR  index := 1  TO  6  DO  Write(mitte, '   ');
     Write('         ');  GotoXY(6,7);  Write('            ');
     FOR  index := 1  TO  6  DO  Write(unten, '   ');
     Write('         ');  GotoXY(6,8);  Write('   ', hoben);
     Write('                                                   ');
     Write(hoben, '   ');   GotoXY(6,9);   Write('   ', hmitte);
     Write('                                                   ');
     Write(hmitte, '   ');  GotoXY(6,10);  Write('   ', hunten);
     Write('                                                   ');
     Write(hunten, '   ');  GotoXY(6,11);  Write('            ');
     FOR  index := 1  TO  6  DO  Write(oben, '   ');
     Write('         ');    GotoXY(6,12);  Write('            ');
     FOR  index := 1  TO  6  DO  Write(mitte, '   ');
     Write('         ');    GotoXY(6,13);  Write('            ');
     FOR  index := 1  TO  6  DO  Write(unten, '   ');
     Write('         ');
     GotoXY(6, 14);
     Write('              1       2');
     Write('       3       4       ');
     Write('5       6              ');
     GotoXY(6, 15);
     Write('                       ');
     Write('                       ');
     Write('                       ');
   END;

(*-------------------------------------------------------------------------*)

PROCEDURE  initialisieren;

   VAR  index  : INTEGER;
        help   :    CHAR;

   BEGIN
     (*   Initialisierung der den Spielablauf kontrollierenden Variablen   *)
     weiter := TRUE;  fertig := FALSE;
     nummer := 0;     zahl   := 100 + 12 * max;
     (*   Das Spielfeld wird initialisiert   *)
     FOR  index := 1  TO  13  DO  spiel[index] := max;
     spiel[0] := 100;  spiel[7] := 0;
     (*   Festlegungen ueber Spielbeginn und Spielstaerke werden getroffen *)
     screen_init;
     GotoXY(20,18);  Write('Wer macht den ersten Zug?  ( M / C )  ');
     REPEAT
       Read(Kbd, anfang);  anfang := UpCase(anfang)
     UNTIL  anfang  IN  ['M','C'];
     GotoXY(13,18);
     Write('Mit welcher Spielstaerke soll ich spielen?  ( 1 / 2 )  ');
     REPEAT  Read(Kbd, help)  UNTIL  help  IN  ['1','2'];
     GotoXY(13,18);
     Write('                                                       ');
     GotoXY(18,18);
     IF  anfang = 'M'  THEN  stark := 2 * (Ord(help) - Ord('0')) + 1
                       ELSE  stark := 2 * (Ord(help) - Ord('0'))
   END;

(* ----------------------------------------------------------------------- *)
(*                         Ende von AWARINIT.INC                           *)
