(*---------------------------------------------------------------------------*)
(*                           DF-MY.INC                                       *)
(*            Dieses Programmmodul enthaelt Routinen, die fuer               *)
(*           verschiedene Dialekte ggf. angepasst werden muessen.            *)

PROCEDURE ClearKeyBuf;

BEGIN
  WHILE KeyPressed DO
    IF Eoln(Kbd) THEN
      ReadLn(Kbd)
    ELSE
      Read(Kbd)
END;



FUNCTION GetKey : CHAR;
  (* Ein Zeichen direkt von der Tastatur lesen OHNE Echo auf dem Bildschirm. *)

VAR Zeichen : CHAR;

BEGIN
  Read(Kbd,Zeichen);
  GetKey := Zeichen
END;



FUNCTION Hi(Wert : INTEGER) : INTEGER;
  (* Liefert das HighByte eines Wertes *)

BEGIN
  Hi := Wert DIV 256
END;



FUNCTION Lo(Wert : INTEGER) : INTEGER;
  (* Liefert das LowByte eines Wertes *)

BEGIN
  Lo := Wert MOD 256
END;

(*-- Routinen um gewisse Zeit zu warten --*)
PROCEDURE Turbo_Delay(milli_sec : INTEGER);
  (* Alte Turbo-Prozedur weiterverwenden. *)

BEGIN
  Delay(milli_sec)
END;

PROCEDURE Delay(milli_sec  : INTEGER);
  (* Diese Routine wird vonm Programm verwendet. *)

BEGIN
  Turbo_Delay(milli_sec)
END;

(*                           Ende DF-MY.INC                                  *)
(*---------------------------------------------------------------------------*)