(*-------------------------------------------------------------------*)
(*                            WRITEDEM.PAS                           *)
(* Demonstration der Zeichenausgabe-Prozedur "GrafWriteXY" anhand    *)
(* verschiedener Schriftarten.                                       *)

PROGRAM WriteDemo(Input,Output);

CONST (*$I GRAFCONS.PAS *)

TYPE  (*$I GRAFTYPE.PAS *)

VAR   (*$I GRAFVAR.PAS *)
      Handle: WinNrBereich;

(*$I GRAPH.P      <-- wird fuer Turbo Pascal unter MS-DOS benoetigt *)
(*$I GRAFSYS.PAS  *)
(*$I INTDDA.PAS   *)
(*$I LINE.PAS     *)
(*$I WINSYS.PAS   *)
(*$I WINGRAF.PAS  *)
(*$I PIXMANI.PAS  *)
(*$I CELLMANI.PAS *)
(*$I GRAFWRIT.PAS *)

BEGIN
  Enter_Graphic;  InitGrafWrite('');  InitWindows;
  Handle := SelectViewport(0,0,ScreenXMax,ScreenYMax);
  SelectWorld(Handle, 0,0,500,500);
  SelectWindow(Handle);
  GrafWriteXY(1,1,'Dies ist normale Schrift !');
  BoldFont := TRUE;
  GrafWriteXY(1,50,'Dies ist fette Schrift !');
  BoldFont := FALSE;  SmallFont := TRUE;
  GrafWriteXY(1,100,'Dies ist Schmalschrift !');
  SmallFont := FALSE;  KursivFont := TRUE;
  GrafWriteXY(1,150,'Dies ist kursive Schrift !');
  KursivFont := FALSE;  DoubleHighFont := TRUE;
  GrafWriteXY(1,200,'Und nun doppelt hohe Schrift !');
  DoubleHighFont := FALSE;  DoubleWideFont := TRUE;
  GrafWriteXY(1,270,'Dies ist dann doppelt breite Schrift !');
  DoubleWideFont := FALSE;  SmallFont := TRUE;  KursivFont := TRUE;
  DoubleHighFont := TRUE;  DoubleWideFont := TRUE;
  GrafWriteXY(1,350,'Schluss: schmal,kursiv,hoch & breit !');
  ReadLn;
  Exit_Graphic;
END.
