(* ----------------------------------------------------------------------- *)
(*                           CALLINTE.INC                                  *)
(* Code fuer das Beenden eines durch CALLINT.INC eingeleiteten Aufrufs
   einer original-Interrupt-Routine. Alle Register werden mit den entsprech-
   enden Aenderungen durch die Interrupt-Routine wiederhergestellt.
   CALLINTE.INC muss unmittelbar nach CALLINT.INC stehen.                  *)

   INLINE (
     $FB/            {    STI                ; neuen HW-Interrupt gestatten}
     $50/            {    PUSH AX            ; Die Register eines Software-}
     $53/            {    PUSH BX            ;    Interrupts werden in die }
     $51/            {    PUSH CX            ;    Variable PgmRegs ge-     }
     $52/            {    PUSH DX            ;    schrieben.               }
     $57/            {    PUSH DI            ;                             }
     $56/            {    PUSH SI            ;                             }
     $06/            {    PUSH ES            ;                             }
     $1E/            {    PUSH DS            ;                             }
     $2E/$A1/$A0/$00/{    MOV AX,CS:[00A0]   ; TURBO braucht unbedingt DS  }
     $50/            {    PUSH AX            ;    (wurde durch IntSet) ge- }
     $1F);           {    POP DS             ;    schrieben                }
(* ----------------------------------------------------------------------- *)
(*                          Ende CALLINTE.INC                              *)
