{***************************************************************************}
{*                                IO.INC                                   *}
{*                      Leseroutine fuer Datenvektor                       *}
{***************************************************************************}
PROCEDURE warten;

BEGIN
  writeln; writeln; Write('weiter:  Taste druecken ... ');
  REPEAT UNTIL KeyPressed; Writeln; Writeln;
END;
{---------------------------------------------------------------------------}
function Ja: BOOLEAN;

var ch: Char;

begin
  repeat read(Kbd, ch); ch := Upcase(ch); until ch in ['J','N'];
  Ja := ch = 'J';  WriteLn(ch);
END;
{---------------------------------------------------------------------------}
PROCEDURE readvector (VAR vec : vector);

VAR datei : TEXT;
    name  : filename;
    i, n  : INTEGER;

BEGIN
  WriteLn; WriteLn; Write('Dateneingabe per Tastatur (J/N) ? ');
  IF Ja THEN
     BEGIN
       REPEAT
         Write('Anzahl der Stichprobenelemente (2 oder mehr) : ');
         ReadLn(n);
       UNTIL n > 1;
       vec.n := n;
       WriteLn('Bitte die Werte eingeben...');
       FOR I := 1 TO n DO
          BEGIN
            Write(I:4,'-ten Wert eingeben :  ');
            ReadLn(vec.value[I]);
          END;
    END
  ELSE
    BEGIN
      repeat
        Write('Name der Datei mit den Stichprobenwerten ? ');
        ReadLn(name);
        if length(name) > 0 then
          begin
            Assign(datei, name);
            (*$I-*)  ReSet(datei);  (*$I+*)
            i := ioresult;
            if i <> 0 then writeln('I/O-Fehler #',i,' !!');
          end;
      until (i = 0) OR (name = '');
      if name <> '' then
        begin
          ReadLn(datei,vec.n);
          FOR I := 1 TO vec.n DO ReadLn(datei, vec.value[I]);
          Close(datei);
        end;
    END;
  writeln;
END;
{--------------------------------------------------------------------------}
{                            Ende IO.INC                                   }
