(* ----------------------------------------------------------- *)
(*                        WHEREXY.PAS                          *)
(*   Ermittlung der aktuellen Cursor-Position fuer Schneider   *)
(*             JOYCE und CPC 6128 unter CP/M 3.0               *)

FUNCTION WhereX : INTEGER;                      (* akt. Spalte *)
VAR x: INTEGER;
BEGIN
  INLINE ($CD/$5A/$FC/  (* CALL FC5A   (XBIOS)                 *)
          $BF/$00/      (* DW   00BF   (Adresse der Routine)   *)
          $22/x);       (* LD   (x),HL (HL-Reg. in x speichern)*)
  WhereX := Succ(Lo(x)) (* Spaltenzaehlung unter CP/M beginnt  *)
END;                    (* bei 0                               *)

FUNCTION WhereY : INTEGER;                       (* akt. Zeile *)
VAR y: INTEGER;
BEGIN
  INLINE ($CD/$5A/$FC/  (* CALL FC5A     dito *)
          $BF/$00/      (* DW   00BF          *)
          $22/y);       (* LD   (y),HL        *)
  WhereY := Succ(Hi(y)) (* Zeilenzaehlung unter CP/M *)
END;                    (* beginnt ebenfalls bei 0   *)
(* ----------------------------------------------------------- *)
(*                        WHEREXY.PAS                          *)
